diff --git a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBase.java b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBase.java
index 88cecea89..d066e7073 100644
--- a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBase.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBase.java
@@ -3,388 +3,573 @@ package net.minecraft.core.block.piston;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.material.Materials;
+import net.minecraft.core.block.piston.PistonCommon.MovingType;
 import net.minecraft.core.block.support.FullSupport;
 import net.minecraft.core.block.support.ISupport;
 import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.block.tag.BlockTags;
-import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.EntityFallingBlock;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.sound.SoundCategory;
+import net.minecraft.core.util.PackedField;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.IVehicle;
 import net.minecraft.core.world.LevelListener;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
+
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.Vector3d;
 import org.joml.primitives.AABBd;
 import org.joml.primitives.AABBdc;
 
+import static net.minecraft.core.block.piston.PistonCommon.*;
+
 public class BlockLogicPistonBase extends BlockLogic {
-    public static final int MASK_DIRECTION = 0b0000_0111;
-    public static final int MASK_POWERED = 0b0000_1000;
-
-    public static final int EVENT_EXTEND = 0;
-    public static final int EVENT_RETRACT = 1;
-
-    public static final ISupport[] pistonSupportLookupTable = {
-        // Bottom
-        PartialSupport.INSTANCE,
-        FullSupport.INSTANCE,
-        PartialSupport.INSTANCE.center().up(),
-        PartialSupport.INSTANCE.center().down(),
-        PartialSupport.INSTANCE.center().right(),
-        PartialSupport.INSTANCE.center().left(),
-        // Top
-        FullSupport.INSTANCE,
-        PartialSupport.INSTANCE,
-        PartialSupport.INSTANCE.center().down(),
-        PartialSupport.INSTANCE.center().up(),
-        PartialSupport.INSTANCE.center().right(),
-        PartialSupport.INSTANCE.center().left(),
-        // North
-        PartialSupport.INSTANCE.center().up(),
-        PartialSupport.INSTANCE.center().down(),
-        PartialSupport.INSTANCE,
-        FullSupport.INSTANCE,
-        PartialSupport.INSTANCE.center().right(),
-        PartialSupport.INSTANCE.center().left(),
-        // South
-        PartialSupport.INSTANCE.center().up(),
-        PartialSupport.INSTANCE.center().down(),
-        FullSupport.INSTANCE,
-        PartialSupport.INSTANCE,
-        PartialSupport.INSTANCE.center().right(),
-        PartialSupport.INSTANCE.center().left(),
-        // West
-        PartialSupport.INSTANCE.center().up(),
-        PartialSupport.INSTANCE.center().down(),
-        PartialSupport.INSTANCE.center().left(),
-        PartialSupport.INSTANCE.center().right(),
-        PartialSupport.INSTANCE,
-        FullSupport.INSTANCE,
-        // East
-        PartialSupport.INSTANCE.center().up(),
-        PartialSupport.INSTANCE.center().down(),
-        PartialSupport.INSTANCE.center().left(),
-        PartialSupport.INSTANCE.center().right(),
-        FullSupport.INSTANCE,
-        PartialSupport.INSTANCE,
-    };
-
-    private final int maxPushedBlocks;
-
-    public BlockLogicPistonBase(@NotNull Block<?> block, int maxPushedBlocks) {
+	public final byte typeId;
+
+    final byte pushLimit, crushLimit;
+    final @Nullable EnumDropCause crushAction;
+    final boolean canPull;
+    final double flingStrength;
+
+    public BlockLogicPistonBase(
+        @NotNull Block<? extends BlockLogicPistonBase> block, 
+        byte typeId,
+        byte pushLimit, byte crushLimit,
+        @Nullable EnumDropCause crushAction, boolean canPull, double flingStrength
+    ) {
         super(block, Materials.PISTON);
-        this.maxPushedBlocks = maxPushedBlocks;
         block.withHardness(0.5F);
+		this.typeId = typeId;
+
+        assert typeId >= 0 && typeId < 3;
+
+        this.pushLimit = pushLimit;
+        this.crushLimit = crushLimit;
+        this.crushAction = crushAction;
+        this.canPull = canPull;
+        this.flingStrength = flingStrength;
     }
 
-    @Override
-    public boolean isSolidRender() {
-        return false;
+    // Piston updates:
+    // =================
+
+    private final boolean signalUpdate(@NotNull World world, @NotNull TilePosc tilePos) {
+        return signalUpdate(world, tilePos, world.getBlockData(tilePos));
     }
 
-    @Override
-    public void onPlacedByMob(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, @NotNull Mob mob, double xHit, double yHit) {
-        Direction placementDirection = mob.getPlacementDirection(side).getOpposite();
-        world.setBlockDataNotify(tilePos, placementDirection.getId());
-        if (!world.isClientSide) {
-            checkIfExtend(world, tilePos);
-        }
+    private final boolean signalUpdate(@NotNull World world, @NotNull TilePosc tilePos, int data) {
+        data = validateBaseData(data, this);
+        
+        final boolean powered = hasNeighborSignal(world, tilePos, Direction.fromId(DIRECTION.get(data)));
+        final boolean extended = IS_EXTENDED.bool(data);
+        final boolean detached = IS_DETACHED.bool(data);
+        
+        if (powered == extended) return false;
+
+        int event = (!detached) ? EVENT_EXTEND : EVENT_DETACH_EXTEND;
+        event |= (powered) ? 0 : 1;
+
+        final var lineInfo = (powered && !detached)
+            ? testLine(world, tilePos, Direction.fromId(DIRECTION.get(data)))
+            : 0;
+        assert (lineInfo & ~0xFF) == 0;
+
+        if (LINE_OBSTRUCTED.bool(lineInfo)) return false;
+        
+        world.triggerEvent(tilePos, event, lineInfo);
+        return true;
     }
 
     @Override
-    public void onPlacedOnSide(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
-        Direction placementDirection = side.getDirection();
-        world.setBlockDataNotify(tilePos, placementDirection.getId());
-        if (!world.isClientSide) {
-            checkIfExtend(world, tilePos);
+    public void triggerEvent(@NotNull World world, @NotNull TilePosc tilePos, int index, int eventData) {
+        assert (eventData & ~0xFF) == 0;
+        final double x, y, z;
+        x = tilePos.x() + 0.5D;
+        y = tilePos.y() + 0.5D;
+        z = tilePos.z() + 0.5D;
+
+        final int data = getValidatedBaseData(world, tilePos, this);
+        final boolean isOut = (index & 1) == 0;
+
+        switch (index & ~1) {
+        default:
+            return;
+        case EVENT_DETACH:
+            break;
+        case EVENT_DETACH_EXTEND:
+            world.setBlockData(tilePos, IS_EXTENDED.set(data, isOut ? 1 : 0));
+            break;
+        case EVENT_EXTEND:
+            if (isOut) {
+                if (!this.extend(world, tilePos, data, eventData)) return;
+            } else {
+                if (world.isClientSide) {
+                    // serverside / singleplayer should have already fixed this 
+                    fixLegacyBaseData(world, tilePos);
+                }
+                this.retract(world, tilePos, data);
+            }
+            break;
         }
-    }
 
-    @Override
-    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
-        checkIfExtend(world, tilePos);
-    }
+        // we let client side compute effects
+        if (Global.isServer) return;
 
-    @Override
-    public void onPlacedByWorld(@NotNull World world, @NotNull TilePosc tilePos) {
-        if (!world.isClientSide && world.getTileEntity(tilePos) == null) {
-            checkIfExtend(world, tilePos);
+        final @NotNull String sound;
+        final float volumn, pitch;
+
+        switch (index & ~1) {
+        default: 
+            assert false;
+            return;
+        case EVENT_DETACH:
+            world.playBlockEvent(tilePos, LevelListener.EVENT_DISPENSER_PARTICLES, DIRECTION.get(data));
+            sound = (isOut) ? "tile.piston.detached" : "tile.piston.attached";
+            volumn = 1.0F;
+            pitch  = 0.6F;
+            break;
+        case EVENT_DETACH_EXTEND:
+            world.playBlockEvent(tilePos, LevelListener.EVENT_DISPENSER_PARTICLES, DIRECTION.get(data));
+            sound = (isOut) ? "tile.piston.detached.out" : "tile.piston.detached.in";
+            volumn = pitch = 1.0F;
+            break;
+        case EVENT_EXTEND:
+            sound = (isOut) ? "tile.piston.out" : "tile.piston.in";
+            volumn = 0.5F;
+            pitch = world.rand.nextFloat() * 0.25F + 0.6F;
+            break;
         }
+
+        world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, x, y, z, sound, volumn, pitch);
     }
+    
+    private static boolean hasNeighborSignal(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Direction dir) {
+        final var queryPos = new TilePos();
+        for (final var search : Direction.all) {
+            queryPos.set(tilePos).add(search);
+            if (search != dir && world.hasSignal(queryPos, search.side())) return true;
 
-    private void checkIfExtend(@NotNull World world, @NotNull TilePosc tilePos) {
-        int data = world.getBlockData(tilePos);
-        Direction direction = getDirection(data);
-        boolean hasNeighborSignal = getNeighborSignal(world, tilePos, direction);
-        if (data == MASK_DIRECTION) {
-            return;
+            // QC
+            if (search == Direction.DOWN) continue;
+            if (dir == Direction.UP && search == Direction.UP) continue;
+            queryPos.up();
+            if (world.hasSignal(queryPos, search.side())) return true;
         }
-        if (hasNeighborSignal && !isPowered(data)) {
-            if (canPushLine(world, tilePos, direction, this.maxPushedBlocks)) {
-                world.setBlockData(tilePos, direction.getId() | MASK_POWERED);
-                world.triggerEvent(tilePos, EVENT_EXTEND, direction.getId());
+        return false;
+    }
+
+    // Piston tests:
+    // =================
+
+    // only uses 8 bits since only 8 bits of PacketBlockEvent's data field
+    private static final PackedField LINE_LENGTH     = new PackedField(0, 6);
+    private static final PackedField CRUSH_EOL       = new PackedField(6, 1);
+    private static final PackedField LINE_OBSTRUCTED = new PackedField(7, 1);
+
+    /**
+     * Returns line length: <br>
+     * {@code LINE_LENGTH.get(n)} encodes length of line; <br>
+     * if {@code LINE_OBSTRUCTED.bool(n)}, line can't be pushed; <br>
+     * if {@code CRUSH_EOL.bool(n)}, end of line should be crushed; <br>
+     */
+    public int testLine(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Direction dir) {
+        final var pos = new TilePos(tilePos).add(dir);
+        final int maxY = world.getHeightBlocks();
+        final int pushLimit = LINE_LENGTH.get(this.pushLimit);
+
+        if (pushLimit == 0) return 0;
+        for (int i = 0; i <= pushLimit; i++, pos.add(dir)) {
+            final int nope = LINE_OBSTRUCTED.mask | i;
+
+            if (pos.y < 0 || pos.y >= maxY) return nope;
+
+            switch (Movability.test(world, pos)) {
+            case BREAKS: 
+                return i;
+            case MOVES:
+                if (i >= pushLimit) return nope;
+                continue;
+            case CRUSHES:
+                if (this.crushAction == null) return nope; 
+                if (i == 0) return nope;
+                if (i > this.crushLimit) return nope;
+                return CRUSH_EOL.mask | i - 1;
+            case OBSTRUCTED:
+                return nope;
             }
-        } else if (!hasNeighborSignal && isPowered(data)) {
-            world.setBlockData(tilePos, direction.getId());
-            world.triggerEvent(tilePos, EVENT_RETRACT, direction.getId());
+            assert false : "unreachable";
         }
+        assert false : "unreachable"; return 0;
     }
 
-    private boolean getNeighborSignal(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Direction direction) {
-        TilePos queryPos = new TilePos();
-        if (direction != Direction.DOWN && world.hasSignal(tilePos.add(0, -1, 0, queryPos), Side.BOTTOM)) {
-            return true;
-        }
-        if (direction != Direction.UP && world.hasSignal(tilePos.add(0, 1, 0, queryPos), Side.TOP)) {
-            return true;
-        }
-        if (direction != Direction.NORTH && world.hasSignal(tilePos.add(0, 0, -1, queryPos), Side.NORTH)) {
-            return true;
-        }
-        if (direction != Direction.SOUTH && world.hasSignal(tilePos.add(0, 0, 1, queryPos), Side.SOUTH)) {
-            return true;
-        }
-        if (direction != Direction.EAST && world.hasSignal(tilePos.add(1, 0, 0, queryPos), Side.EAST)) {
-            return true;
-        }
-        if (direction != Direction.WEST && world.hasSignal(tilePos.add(-1, 0, 0, queryPos), Side.WEST)) {
-            return true;
-        }
-        if (world.hasSignal(tilePos, Side.BOTTOM)) {
-            return true;
-        }
-        // QC
-        if (direction != Direction.UP && world.hasSignal(tilePos.add(0, 2, 0, queryPos), Side.TOP)) {
-            return true;
+    public static enum Movability {
+        OBSTRUCTED, MOVES, BREAKS, CRUSHES;
+
+        public static @NotNull Movability test(@NotNull World world, @NotNull TilePosc tilePos) {
+            final var block = world.getBlockType(tilePos);
+            if (block == Blocks.AIR) return BREAKS;
+            if (block.hasTag(BlockTags.PISTON_CRUSHING)) return CRUSHES;
+            switch (block.getPistonPushReaction(world, tilePos)) {
+                case Material.PISTON_DESTROY_ON_PUSH: return BREAKS;
+                case Material.PISTON_CANT_PUSH: return OBSTRUCTED;
+            }
+            if (block.getImmovable() || block.getHardness() == -1F) return OBSTRUCTED;
+            return MOVES;
         }
-        if (world.hasSignal(tilePos.add(0, 1, -1, queryPos), Side.NORTH)) {
-            return true;
+    }
+
+    // Piston Events:
+    // ==================
+    //  ├─ extend 
+    //  │  ├─ push
+    //  │  ├─ destroy (breakTail)
+    //  │  ├─ ?crush (breakTail)
+    //  │  ├─ ?flingEntity
+    //  │  └─ ?flingBlock
+    //  └─ retract
+    //     └─ ?pull
+    // 
+
+    private boolean extend(@NotNull World world, @NotNull TilePosc tilePos, int data, int lineInfo) {
+        data = validateBaseData(data, this);
+        final var dir = Direction.fromId(DIRECTION.get(data));
+        final var headPos = new TilePos(tilePos).add(dir);
+
+        world.setBlockData(tilePos, IS_EXTENDED.set(data, 1));
+        world.markBlockNeedsUpdate(tilePos);
+
+        final boolean canFling = !Double.isNaN(this.flingStrength);
+        if (canFling) flingEntity(world, headPos, dir);
+
+        final int len = LINE_LENGTH.get(lineInfo);
+        final boolean shouldCrush = CRUSH_EOL.bool(lineInfo);
+        final boolean shouldFling = !shouldCrush && canFling && len == 1;
+        if (shouldFling) {
+            flingBlock(world, headPos, dir);
+        } else {
+            final var tailAction = (shouldCrush) ? this.crushAction : EnumDropCause.WORLD;
+            breakTail(tailAction, world, headPos, dir, len);
+            push(world, headPos, dir, len);
         }
-        if (world.hasSignal(tilePos.add(0, 1, 1, queryPos), Side.SOUTH)) {
-            return true;
+
+        final var headData = DIRECTION.set(0, dir.id) | TYPE.getNoShift(data);
+        final var headMoving = new TileEntityMovingPistonBlock(
+            MovingType.EXTENDING_PISTON,
+            HEAD_BLOCK_MAP[TYPE.get(data)], headData, null, dir);
+
+        world.setBlockTypeDataEntity(headPos, Blocks.PISTON_MOVING, headData, headMoving);
+
+        // extension updates base immediately, and head 3 ticks after 
+        world.notifyBlocksOfNeighborChange(tilePos, this.block);
+
+        return true;
+    }
+
+    private static void push(@NotNull World world, @NotNull TilePosc headPos, @NotNull Direction dir, int len) {
+        final var src = new TilePos();
+        final var tar = new TilePos();
+
+        for (int i = len - 1; i >= 0; i--) {
+            src.set(headPos);
+            dir.offsetScaled(src, i);
+            tar.set(src);
+            dir.offset(tar);
+
+            final @NotNull Block<?> block;
+            final int data;
+            var entity = world.getTileEntity(src);
+            
+            if (entity instanceof TileEntityMovingPistonBlock moving && !moving.isSourcePiston) {
+                assert world.getBlockType(src) == Blocks.PISTON_MOVING;
+                block = moving.movingBlock;
+                data = moving.movingBlockData;
+                entity = moving.movingTileEntity;
+            } else {
+                block = world.getBlockType(src);
+                data = world.getBlockData(src);
+            }
+
+            world.removeTileEntity(src);
+            final var moving = new TileEntityMovingPistonBlock(
+                MovingType.EXTENDING,
+                block, data, entity, dir);
+            world.setBlockTypeDataEntity(tar, Blocks.PISTON_MOVING, data, moving);
+
+            if (i >= 1) world.setBlockTypeRaw(src, Blocks.AIR);
         }
-        if (world.hasSignal(tilePos.add(-1, 1, 0, queryPos), Side.WEST)) {
-            return true;
+    }
+
+    private void breakTail(
+        @NotNull EnumDropCause cause, @NotNull World world, @NotNull TilePosc headPos,
+        @NotNull Direction dir, int off
+    ) {
+        final var target = dir.offsetScaled(new TilePos(headPos), off);
+
+        final var block = world.getBlockType(target);
+        if (block.id() > 0) {
+            world.playBlockEvent(null, target, LevelListener.EVENT_BLOCK_BREAK, block.id());
         }
-        return world.hasSignal(tilePos.add(1, 1, 0, queryPos), Side.EAST);
+
+        block.dropWithCause(world, cause, target, world.getBlockData(target), world.getTileEntity(target), null);
+        world.setBlockType(target, Blocks.AIR);
     }
 
-    @Override
-    public void triggerEvent(@NotNull World world, @NotNull TilePosc tilePos, int index, int data) {
-        Direction direction = getDirection(data);
-        if (direction == Direction.NONE) return;
-        if (index == EVENT_EXTEND) {
-            extendEvent(world, tilePos, data, direction);
-        } else if (index == EVENT_RETRACT) {
-            retractEvent(world, tilePos, data, direction);
+    private void flingEntity(@NotNull World world, @NotNull TilePosc headPos, @NotNull Direction dir) {
+        if (world.isClientSide) return;
+        final double vx = dir.offsetX() * this.flingStrength;
+        final double vy = dir.offsetY() * this.flingStrength;
+        final double vz = dir.offsetZ() * this.flingStrength;
+        final var entities = world.getEntitiesWithinAABBExcludingEntity(null,
+            new AABBd(new Vector3d(headPos.vec()), new Vector3d(headPos.vec()).add(1, 1, 1)));
+        // note that flingEntity is performed before flingBlock, therefore no need to 
+        // check for flingBlock
+        for (final var entity : entities) {
+            entity.fling(vx, vy, vz, 1f);
         }
     }
 
-    public void extendEvent(@NotNull World world, @NotNull TilePosc tilePos, int data, @NotNull Direction direction) {
-        if (tryExtend(world, tilePos, direction, this.maxPushedBlocks)) {
-            world.setBlockDataNotify(tilePos, direction.getId() | MASK_POWERED);
-            world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double) tilePos.x() + 0.5D, (double) tilePos.y() + 0.5D, (double) tilePos.z() + 0.5D, "tile.piston.out", 0.5F, world.rand.nextFloat() * 0.25F + 0.6F);
+    private void flingBlock(@NotNull World world, @NotNull TilePosc headPos, @NotNull Direction dir) {
+        final double vx = dir.offsetX() * this.flingStrength;
+        final double vy = dir.offsetY() * this.flingStrength;
+        final double vz = dir.offsetZ() * this.flingStrength;
+
+        final var block = world.getBlockType(headPos);
+        if (block == Blocks.AIR) return;
+
+        final int blockMeta = world.getBlockData(headPos);
+        final var tileEntity = world.getTileEntity(headPos);
+        world.removeTileEntity(headPos);
+        world.setBlockTypeNotify(headPos, Blocks.AIR);
+        
+        if (world.isClientSide) return;
+        
+        var flungBlock = new EntityFallingBlock(world, 
+            headPos.x() + 0.5, headPos.y() + 0.5, headPos.z() + 0.5,
+            block.id(), blockMeta, tileEntity);
+        flungBlock.hasRemovedBlock = true;
+
+        if (tileEntity instanceof IVehicle vehicle) {
+            var rider = vehicle.ejectRider();
+            if (rider != null) rider.startRiding(flungBlock); // TODO: ride packet after entity packet
         }
+
+        world.entityJoinedWorld(flungBlock);
+        flungBlock.fling(vx, vy, vz, 1f);
     }
 
-    public void retractEvent(@NotNull World world, @NotNull TilePosc tilePos, int data, @NotNull Direction direction) {
-        TilePos shiftedPos = tilePos.add(direction, new TilePos());
-        TileEntity tileEntity = world.getTileEntity(shiftedPos);
-        if ((tileEntity instanceof TileEntityMovingPistonBlock moving)) {
-            if (!moving.isExtending()) {
+    private void retract(@NotNull World world, @NotNull TilePosc tilePos, int data) {
+        data = validateBaseData(data, this);
+        final var dir = Direction.fromId(DIRECTION.get(data));
+        final var headPos = new TilePos(tilePos).add(dir);
+
+        if (world.getTileEntity(headPos) instanceof TileEntityMovingPistonBlock moving) {
+            if (!moving.isExtending) {
                 moving.finalTick();
             } else {
-                world.setBlockType(shiftedPos, Blocks.AIR);
+                world.setBlockType(headPos, Blocks.AIR);
             }
         }
-        world.setBlockTypeData(tilePos, Blocks.PISTON_MOVING, direction.getId());
-        world.replaceTileEntity(tilePos, BlockLogicPistonMoving.createTileEntity(this.block, direction.getId(), null, direction, false, true));
-        world.setBlockTypeNotify(shiftedPos, Blocks.AIR);
-        world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double) tilePos.x() + 0.5D, (double) tilePos.y() + 0.5D, (double) tilePos.z() + 0.5D, "tile.piston.in", 0.5F, world.rand.nextFloat() * 0.15F + 0.6F);
-    }
 
-    @Override
-    public @NotNull AABBdc getBoundsFromState(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
-        int data = source.getBlockData(tilePos);
-        if (isPowered(data)) {
-            return switch (getDirection(data)) {
-                case DOWN -> new AABBd(0.0F, 0.25F, 0.0F, 1.0F, 1.0F, 1.0F);
-                case UP -> new AABBd(0.0F, 0.0F, 0.0F, 1.0F, 0.75F, 1.0F);
-                case NORTH -> new AABBd(0.0F, 0.0F, 0.25F, 1.0F, 1.0F, 1.0F);
-                case SOUTH -> new AABBd(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 0.75F);
-                case WEST -> new AABBd(0.25F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
-                default -> new AABBd(0.0F, 0.0F, 0.0F, 0.75F, 1.0F, 1.0F);
-            };
+        final var moving = new TileEntityMovingPistonBlock(
+            MovingType.RETRACTING_PISTON,
+            this.block, dir.id, null, dir);
+        world.setBlockTypeDataEntity(tilePos, Blocks.PISTON_MOVING, data, moving);
+
+        if (this.canPull) {
+            pull(world, headPos, dir);
         } else {
-            return new AABBd(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
+            world.setBlockType(headPos, Blocks.AIR);
+            world.removeTileEntity(headPos);
         }
+
+        // logically, retraction should only update head immediately, and base 3 ticks after
+        // but this emulates the old behavior
+        world.notifyBlocksOfNeighborChange(tilePos, this.block);
+        world.notifyBlocksOfNeighborChange(headPos, Blocks.AIR);
+    }
+
+    private static void pull(@NotNull World world, @NotNull TilePosc headPos, @NotNull Direction dir) {
+        final var tar = headPos;
+        final var src = new TilePos(tar).add(dir);
+
+        final var entity = world.getTileEntity(src);
+
+        if (entity instanceof TileEntityMovingPistonBlock moving) position_moving: {
+            if (moving.direction != dir) break position_moving;
+            if (!moving.isExtending) break position_moving;
+            assert world.getBlockType(src) == Blocks.PISTON_MOVING;
+
+            // 0t
+            moving.finalTick();
+            return;
+        }
+
+        if (Movability.test(world, src) != Movability.MOVES) {
+            world.removeTileEntity(tar);
+            return;
+        }
+        
+        final var block = world.getBlockType(src);
+        final var data = world.getBlockData(src);
+
+        world.removeTileEntity(src);
+        final var moving = new TileEntityMovingPistonBlock(
+            MovingType.RETRACTING,
+            block, data, entity, dir);
+        world.setBlockTypeDataEntity(tar, Blocks.PISTON_MOVING, data, moving);
+
+        world.setBlockTypeNotify(src, Blocks.AIR);
     }
 
+    // BlockLogic impl:
+    // ====================
+
     @Override
-    public boolean isCubeShaped() {
+    public boolean isSolidRender() {
         return false;
     }
-
+    
     @Override
-    public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
-        int meta = world.getBlockData(tilePos);
-        if ((meta & MASK_POWERED) == 0) return FullSupport.INSTANCE;
-        Direction dir = getDirection(meta);
-        return pistonSupportLookupTable[side.getId() * 6 + dir.getId()];
+    public int getPlacedData(
+        @Nullable Player player, @NotNull ItemStack itemStack, @NotNull World world,
+        @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit
+    ) {
+        int meta = 0;
+        meta |= TYPE.set(meta, this.typeId);
+        meta |= NEW_FORMAT_SIGNATURE.mask;
+
+        meta |= IS_DETACHED_OR_EXTENDED.setNoShift(meta, itemStack.getMetadata());
+        final var dir = (player != null)
+            ? player.getPlacementDirection(side).opposite().id
+            : side.id;
+        meta |= DIRECTION.set(meta, dir);
+
+        return meta;
     }
 
-    public static Direction getDirection(int data) {
-        return Direction.getDirectionById(data & MASK_DIRECTION);
+    @Override
+    public void onPlacedByWorld(@NotNull World world, @NotNull TilePosc tilePos) {
+        if (world.isClientSide) return;
+        final var d = NEW_FORMAT_SIGNATURE.set(world.getBlockData(tilePos), 1);
+        world.setBlockData(tilePos, d);
+        this.signalUpdate(world, tilePos);
     }
 
-    public static boolean isPowered(int data) {
-        return (data & MASK_POWERED) != 0;
+    @Override
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
+        if (world.isClientSide) return;
+        final var data = fixLegacyBaseData(world, tilePos);
+        this.signalUpdate(world, tilePos, data);
     }
 
-    protected boolean isPushable(final @NotNull Block<?> block, @NotNull World world, @NotNull TilePos tilePos, boolean canDestroy) {
-        int pushReaction = block.getPistonPushReaction(world, tilePos);
-        return !block.hasTag(BlockTags.PISTON_CRUSHING) &&
-            !block.getImmovable() &&
-            pushReaction != Material.PISTON_CANT_PUSH &&
-            (canDestroy || pushReaction != Material.PISTON_DESTROY_ON_PUSH) &&
-            block.getHardness() != -1F;
+    @Override
+    public @NotNull AABBdc getBoundsFromState(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
+        int data = getValidatedBaseData(source, tilePos, this);
+        if (!IS_DETACHED_OR_EXTENDED.bool(data)) return new AABBd(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
+
+        final var dir = Direction.fromId(DIRECTION.get(data));
+        final var thickness = HEAD_BLOCK_MAP[this.typeId].getLogic().headThickness;
+
+        final var min = new Vector3d(0);
+        final var max = new Vector3d(1);
+
+        dir.offsetScaled(dir.isPositive() ? max : min, (dir.isNegative()) ? thickness : -thickness);
+        return new AABBd(min, max);
     }
 
     @Override
-    public int getPistonPushReaction(@NotNull World world, @NotNull TilePosc tilePos) {
-        if (isPowered(world.getBlockData(tilePos))) {
-            return Material.PISTON_CANT_PUSH;
-        }
-        return super.getPistonPushReaction(world, tilePos);
+    public boolean isCubeShaped() {
+        return false;
     }
 
-    protected boolean canPushLine(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Direction direction, int maxPushedBlocks) {
-        TilePos posO = tilePos.add(direction, new TilePos());
-        int blocks = 0;
-        while (true) {
-            if (blocks >= maxPushedBlocks + 1) {
-                break;
-            }
-            if (posO.y < 0 || posO.y >= world.getHeightBlocks()) {
-                return false;
-            }
-            final @NotNull Block<?> block = world.getBlockType(posO);
-            if (block == Blocks.AIR) {
-                break;
-            }
-            if (!isPushable(block, world, posO, true)) {
-                if (blocks == 1 && block.hasTag(BlockTags.PISTON_CRUSHING) && tryCrush(world, tilePos, direction)) {
-                    break;
-                }
-                return false;
-            }
-            if (block.getPistonPushReaction(world, posO) == Material.PISTON_DESTROY_ON_PUSH) {
-                break;
-            }
-            if (blocks == maxPushedBlocks) {
-                return false;
-            }
-            posO.x += direction.getOffsetX();
-            posO.y += direction.getOffsetY();
-            posO.z += direction.getOffsetZ();
-            blocks++;
-        }
-        return true;
+    private static final ISupport[] SUPPORT_LUT;
+    static {
+        final var F = FullSupport.INSTANCE;
+        final var P = PartialSupport.INSTANCE;
+        final PartialSupport U,D,L,R;
+        U = P.center().up();
+        D = P.center().down();
+        L = P.center().left();
+        R = P.center().right();
+        
+        SUPPORT_LUT = new ISupport[] {
+            P,F, U,D, R,L, // Bottom
+            F,P, D,U, R,L, // Top
+            U,D, P,F, R,L, // North
+            U,D, F,P, R,L, // South
+            U,D, L,R, P,F, // West
+            U,D, L,R, F,P, // East
+        };
     }
 
-    public boolean tryCrush(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Direction direction) {
-        TilePos pos2 = tilePos.add(direction, new TilePos());
-        Block<?> block = world.getBlockType(pos2);
-        world.playBlockEvent(null, pos2, LevelListener.EVENT_BLOCK_BREAK, world.getBlockType(pos2).id());
-        block.dropWithCause(world, EnumDropCause.SILK_TOUCH, pos2, world.getBlockData(pos2), null, null);
-        world.setBlockTypeNotify(pos2, Blocks.AIR);
-        return true;
+    @Override
+    public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
+        final int data = getValidatedBaseData(world, tilePos, this);
+        final int dir = Direction.fromId(DIRECTION.get(data)).id; // ensures < 6
+
+        return (!IS_DETACHED_OR_EXTENDED.bool(data))
+            ? FullSupport.INSTANCE
+            : SUPPORT_LUT[side.id * 6 + dir];
     }
 
-    protected boolean tryExtend(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Direction direction, int maxPushedBlocks) {
-        int data = world.getBlockData(tilePos);
-        TilePos posO = tilePos.add(direction, new TilePos());
-        int blocks = 0;
-        while (true) {
-            if (blocks >= maxPushedBlocks + 1) {
-                break;
-            }
-            if (posO.y < 0 || posO.y >= world.getHeightBlocks()) {
-                return false;
-            }
-            final @NotNull Block<?> block = world.getBlockType(posO);
-            if (block == Blocks.AIR) {
-                break;
-            }
-            if (!isPushable(block, world, posO, true)) {
-                return false;
-            }
-            if (block.getPistonPushReaction(world, posO) == Material.PISTON_DESTROY_ON_PUSH) {
-                block.dropWithCause(world, EnumDropCause.WORLD, posO, world.getBlockData(posO), world.getTileEntity(posO), null);
-                break;
-            }
-            if (blocks == maxPushedBlocks) {
-                return false;
-            }
-            posO.x += direction.getOffsetX();
-            posO.y += direction.getOffsetY();
-            posO.z += direction.getOffsetZ();
-            blocks++;
-        }
-        TilePos posP = new TilePos(posO);
-        while (!posO.equals(tilePos)) {
-            posP.set(posO.x - direction.getOffsetX(), posO.y - direction.getOffsetY(), posO.z - direction.getOffsetZ());
-            @NotNull Block<?> pushBlock = world.getBlockType(posP);
-            int pushMeta = world.getBlockData(posP);
-            TileEntity pushEntity = world.getTileEntity(posP);
-            if (pushEntity instanceof TileEntityMovingPistonBlock && posP.equals(tilePos)) {
-                break;
-            }
-            if (pushBlock == this.block && posP.equals(tilePos)) {
-                createPistonHeadAt(world, posO, data, direction);
-            } else if (pushBlock == Blocks.PISTON_MOVING) {
-                TileEntity old = world.getTileEntity(posP);
-                if (old instanceof TileEntityMovingPistonBlock moving) {
-                    if (!moving.isSourcePiston()) {
-                        pushBlock = moving.getMovedBlock();
-                        pushMeta = moving.getMovedData();
-                        pushEntity = moving.getMovedEntity();
-                    }
-                }
-                world.removeTileEntity(posP);
-                world.setBlockTypeData(posO, Blocks.PISTON_MOVING, pushMeta);
-                world.replaceTileEntity(posO, BlockLogicPistonMoving.createTileEntity(pushBlock, pushMeta, pushEntity, direction, true, false));
-            } else {
-                world.removeTileEntity(posP);
-                world.setBlockTypeData(posO, Blocks.PISTON_MOVING, pushMeta);
-                world.replaceTileEntity(posO, BlockLogicPistonMoving.createTileEntity(pushBlock, pushMeta, pushEntity, direction, true, false));
-            }
-            if (!posP.equals(tilePos)) {
-                world.setBlockTypeRaw(posP, Blocks.AIR);
-            }
-            posO.set(posP.x, posP.y, posP.z);
-        }
+    @Override
+    public int getPistonPushReaction(@NotNull World world, @NotNull TilePosc tilePos) {
+        final var data = fixLegacyBaseData(world, tilePos);
 
-        return true;
+        return (IS_DETACHED_OR_EXTENDED.bool(data))
+            ? Material.PISTON_CANT_PUSH
+            : super.getPistonPushReaction(world, tilePos);
     }
 
-    public void createPistonHeadAt(@NotNull World world, @NotNull TilePos tilePos, int data, @NotNull Direction direction) {
-        world.setBlockTypeData(tilePos, Blocks.PISTON_MOVING, BlockLogicPistonHead.setPistonType(BlockLogicPistonHead.TYPE_NORMAL, direction.getId()));
-        world.replaceTileEntity(tilePos, BlockLogicPistonMoving.createTileEntity(Blocks.PISTON_HEAD, BlockLogicPistonHead.setPistonType(BlockLogicPistonHead.TYPE_NORMAL, direction.getId()), null, direction, true, false));
+    @Override
+    public void onRemoved(@NotNull World world, @NotNull TilePosc tilePos, int data) {
+        data = validateBaseData(data, this);
+        if (IS_DETACHED.bool(data)) return;
+
+        final var dir = Direction.fromId(DIRECTION.get(data));
+        final var hpos = new TilePos(tilePos).add(dir);
+        final var head = world.getBlockType(hpos).getLogic();
+
+        if (head instanceof BlockLogicPistonHead) {
+            final int hdat = getValidatedHeadData(world, hpos);
+            if (hdat == DATA_INVALID) return;
+            if (PAIR_COMPARISON.get(data ^ hdat) != 0) return;
+            world.setBlockTypeNotify(hpos, Blocks.AIR);
+        }
+        else if (head instanceof BlockLogicPistonMoving) {
+            if (!(world.getTileEntity(hpos) instanceof TileEntityMovingPistonBlock moving)) return;
+            if (!moving.isSourcePiston) return;
+            if (moving.direction != dir) return;
+            world.removeTileEntity(hpos);
+            world.setBlockTypeNotify(hpos, Blocks.AIR);
+        }
     }
 
     @Override
-    public int getPlacedData(@Nullable Player player, @NotNull ItemStack itemStack, @NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
-        return MASK_DIRECTION;
+    public @NotNull ItemStack @Nullable [] getBreakResult(
+        @NotNull World world, @NotNull EnumDropCause dropCause,
+        int data, @Nullable TileEntity tileEntity
+    ) {
+        class ctx {
+            static final ItemStack[] buf = new ItemStack[1];
+        }
+
+        data = validateBaseData(data, this);
+        data = DIRECTION.set(data, 0) & IS_EXTENDED.set(data, 0);
+
+        ctx.buf[0] = new ItemStack(this.block, 1, data);
+        return ctx.buf;
     }
 }
